import refreshTokenHelper from "../../../utils/refreshTokenHelper"
import getTokenHelper from "../../../utils/getTokenHelper"
import forceLogoutHelper from "../../../utils/forceLogoutHelper"
import errorHandlingHelper from "../../../utils/errorHandlingHelper"
import fetchHelper from "../../../utils/fetchHelper"

const handleFunc = async (event: any, authToken: any = null) => {
  let data: any = {}
  const config = useRuntimeConfig()
  const token = authToken ?? await getTokenHelper(event)
  const body = await readBody(event)

  let newObjValue = {}
  if(body.discountTypeId) {
    newObjValue = {...newObjValue, DiscountType: {
      id: body.discountTypeId
    }}
  }
  if(body.cumulativeLevelId) {
    newObjValue = {...newObjValue, CumulativeLevel: {
      id: body.cumulativeLevelId
    }}
  }

  const res: any = await fetchHelper(event, 'models/m_discountschema/'+body.id, 'PUT', token, {
    isActive: body.isActive,
    name: body.name,
    description: body.description,
    validFrom: body.validFrom,
    isQuantityBased: body.isQuantityBased,
    isBPartnerFlatDiscount: body.isBPartnerFlatDiscount,
    flatDiscount: body.flatDiscount,
    ...newObjValue,
    tableName: 'M_Discountschema'
  })
  if(res) {
    data = res
    data['status'] = 200
    data['message'] = ''
  }

  return data
}

export default defineEventHandler(async (event) => {
  let data: any = {}

  try {
    data = await handleFunc(event)
  } catch(err: any) {
    try {
      let authToken: any = await refreshTokenHelper(event)
      data = await handleFunc(event, authToken)
    } catch(error: any) {
      data = errorHandlingHelper(err?.data ?? err, error?.data ?? error)
      forceLogoutHelper(event, data)
    }
  }

  return data
})